/*
* HMG Virtual Grid Demo
* (c) 2009 Roberto Lopez
*/

#include "hmg.ch"

Function Main

Local aValue := { Nil , Nil }

	* Grid Column Controls Definitions

	aCtrl_1 := {'TEXTBOX','NUMERIC','9999999999'}
	aCtrl_2 := {'TEXTBOX','CHARACTER'}
	aCtrl_3 := {'TEXTBOX','CHARACTER'}
	aCtrl_4 := {'DATEPICKER','UPDOWN'}
	aCtrl_5 := { 'CHECKBOX' , 'Yes' , 'No' }
	aCtrl_6 := { 'TEXTBOX','CHARACTER' }

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 800 ;
		HEIGHT 510 ;
		TITLE 'Hello World!' ;
		MAIN 

		DEFINE MAIN MENU 
			POPUP 'File'
				ITEM 'Append (Alt+A)'				ACTION Form_1.Grid_1.Append
				ITEM 'Set RecNo'				ACTION Form_1.Grid_1.RecNo := val(InputBox('','')) 
				ITEM 'Get RecNo'				ACTION MsgInfo( Str(Form_1.Grid_1.RecNo) )
				ITEM 'Delete (Alt+D)'				ACTION Form_1.Grid_1.Delete
				ITEM 'Recall (Alt+R)'				ACTION Form_1.Grid_1.Recall
				ITEM 'Get Value'				ACTION ( aValue := Form_1.Grid_1.Value , MsgInfo( Str( aValue [1] ) + ' , ' + Str( aValue [2] ) ) )
				ITEM 'Set Value'				ACTION ( aValue [ 1 ] :=  val(InputBox('New Row','Selected Cell (Value)')) , aValue [ 2 ] :=  val(InputBox('New Col','Selected Cell (Value)')) , Form_1.Grid_1.Value := { aValue [ 1 ] , aValue [ 2 ] } )
				ITEM 'Save Pending Changes (Alt+S)'		ACTION Form_1.Grid_1.Save
				ITEM 'Clear Changes Buffer (Undo) (ALt+U)'	ACTION Form_1.Grid_1.ClearBuffer
			END POPUP
		END MENU

		USE TEST // SHARED

		INDEX ON CODE TO CODE

		GO TOP

		@ 10,10 GRID Grid_1 ;
			WIDTH 770 ;
			HEIGHT 440 ;
			HEADERS {'Code','First name','Last name','Birth date','Married','CheckBoxes'} ;
			WIDTHS {140,140,140,100,100,100};
			EDIT ;
			COLUMNWHEN 	{ ;
					Nil , ;
					Nil , ;
					Nil , ;
					Nil , ;
					Nil , ;					
					{ || GetCheckBoxs ( Form_1.Grid_1.RecNo ) } ;
					} ;
			VALUE { 1 , 1 } ;
			COLUMNCONTROLS { aCtrl_1 , aCtrl_2 , aCtrl_3 , aCtrl_4 , aCtrl_5 , aCtrl_6 } ;
			ROWSOURCE "Test" ;
			COLUMNFIELDS { 'Code' ,  'First' , 'Last' ,  'Birth' , 'Married' , "' >> Show << '" /* dummy value */ } ;
			ALLOWAPPEND ;
			ALLOWDELETE  

//COLUMNFIELDS { 'Code' ,  'First' , 'Last' ,  'Birth' , 'Married' , 'CheckBoxs' } ;
		
	END WINDOW

	CENTER WINDOW Form_1

	ACTIVATE WINDOW Form_1

Return

**********************************************************************************************
Function GetCheckBoxs ( nRecNo )
Local nDec, i, nRow:=20, nCol:=20

/* Array up to 32 checkboxes (32 bits) */
Local aCheckBox:= { {'Chbox_01' /* control name */ , 'This is a CheckBox #1' /* control caption */ , .T. /* control enabled */ }, ; 
		  {'Chbox_02' , 'This is a CheckBox #2' , .T. }, ;
		  {'Chbox_03' , 'This is a CheckBox #3' , .F. /* intentionaly disabled */}, ;
		  {'Chbox_04' , 'This is a CheckBox #4' , .T. }, ;
		  {'Chbox_05' , 'This is a CheckBox #5' , .T. }, ;
		  {'Chbox_06' , 'This is a CheckBox #6' , .T. }, ;
		  {'Chbox_07' , 'This is a CheckBox #7' , .T. }, ;
		  {'Chbox_08' , 'This is a CheckBox #8' , .T. }, ;
		  {'Chbox_09' , 'This is a CheckBox #9' , .T. }, ;
		  {'Chbox_10' , 'This is a CheckBox #10' , .T. }, ;
		  {'Chbox_11' , 'This is a CheckBox #11' , .T. }, ;
		  {'Chbox_12' , 'This is a CheckBox #12' , .T. }, ;
		  {'Chbox_13' , 'This is a CheckBox #13' , .T. }, ;
		  {'Chbox_14' , 'This is a CheckBox #14' , .T. }, ;
		  {'Chbox_15' , 'This is a CheckBox #15' , .T. }, ;
		  {'Chbox_16' , 'This is a CheckBox #16' , .T. }, ;
		  {'Chbox_17' , 'This is a CheckBox #17' , .T. }, ;
		  {'Chbox_18' , 'This is a CheckBox #18' , .T. }, ;
		  {'Chbox_19' , 'This is a CheckBox #19' , .T. }, ;
		  {'Chbox_20' , 'This is a CheckBox #20' , .T. }, ;
		  {'Chbox_21' , 'This is a CheckBox #21' , .T. }, ;
		  {'Chbox_22' , 'This is a CheckBox #22' , .T. }, ;
		  {'Chbox_23' , 'This is a CheckBox #23' , .T. }, ;
		  {'Chbox_24' , 'This is a CheckBox #24' , .T. }, ;
		  {'Chbox_25' , 'This is a CheckBox #25' , .T. }, ;
		  {'Chbox_26' , 'This is a CheckBox #26' , .T. }, ;
		  {'Chbox_27' , 'This is a CheckBox #27' , .T. }, ;
		  {'Chbox_28' , 'This is a CheckBox #28' , .T. }, ;
		  {'Chbox_29' , 'This is a CheckBox #29' , .T. }, ;
		  {'Chbox_30' , 'This is a CheckBox #30' , .T. }, ;
		  {'Chbox_31' , 'This is a CheckBox #31' , .T. }, ;
		  {'Chbox_32' , 'This is a CheckBox #32' , .T. } }

GOTO nRecNo
nDec:=Bin2L ( Alltrim( test->checkboxs ) )  // convert binary string to 32-bit long decimal

DEFINE WINDOW Form_2 AT 216 , 390 WIDTH 550 HEIGHT 510 TITLE "CheckBoxes" CHILD

FOR i=1 TO LEN( aCheckBox )

    DEFINE CHECKBOX &(aCheckBox [i] [1])
        ROW    nRow
        COL    nCol
        WIDTH  245
        HEIGHT 20
        CAPTION aCheckBox [i] [2]  
        VALUE IsBit( nDec, i )	/* check i-th bit */  
        FONTNAME "Arial"
        FONTSIZE 9
        ONCHANGE This.FontBold:=This.Value
        FONTBOLD IsBit( nDec, i )
    END CHECKBOX

    SetProperty("Form_2", aCheckBox [i] [1], "Enabled", aCheckBox [i] [3])

    nRow +=25

    IF i=16	//second column
	nRow:=20
        nCol:=285
    ENDIF

NEXT i 

    DEFINE BUTTON Button_OK
        ROW    430
        COL    280
        WIDTH  100
        HEIGHT 28
        ACTION (nDec:=SetBits( aCheckBox, "Form_2" ), ThisWindow.Release )
        CAPTION "OK"
    END BUTTON

    DEFINE BUTTON Button_Cancel
        ROW    430
        COL    410
        WIDTH  100
        HEIGHT 28
        ACTION ThisWindow.Release
        CAPTION "Cancel"
    END BUTTON

END WINDOW

Form_2.Center
Form_2.Activate

REPLACE test->checkboxs WITH L2Bin (nDec)		//convert 32-bit long decimal to binary string
RETURN .F.

****************************************************************************
Function SetBits( aCheckBox, cFname )
Local nBitfield:=0, i

FOR i=1 TO Len (aCheckBox)
	IF GetProperty (cFname, aCheckBox [i] [1], "Value")
		nBitfield:=SetBit(nBitfield, i)
	ENDIF
NEXT i
RETURN nBitfield